(*

Das Paket libsqlite3-dev mus installiert werden.

sudo aptitude install libsqlite3-dev

Der SQLite Befehlssatz unterscheidet sich ein klein wenig zu MySQL

Für Lazarus mus das Paket

SQLDBLaz

installiert werden.

für mehr Details siehe :

http://www.sqlite.org/sqlite.html

oder

http://www.sqlite.org/lang.html -- SYNTAX

oder

http://reeg.junetz.de/DSP/node10.html#SECTION04220000000000000000

*)

Unit Unit1;

{$MODE objfpc}{$H+}

Interface

Uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  DbCtrls, sqldb, sqlite3conn, mysql50conn, db, math, lclproc;

Type

  { TForm1 }

  TForm1 = Class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    OpenDialog1: TOpenDialog;
    SQLite3Connection1: TSQLite3Connection;
    SQLQuery1: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure Button3Click(Sender: TObject);
    Procedure Button4Click(Sender: TObject);
    Procedure Button5Click(Sender: TObject);
    Procedure Button6Click(Sender: TObject);
    Procedure FormChangeBounds(Sender: TObject);
    Procedure FormClose(Sender: TObject; Var CloseAction: TCloseAction);
    Procedure FormCloseQuery(Sender: TObject; Var CanClose: boolean);
    Procedure FormCreate(Sender: TObject);
    Procedure Memo1KeyDown(Sender: TObject; Var Key: Word; Shift: TShiftState);
  private
    { private declarations }
  public
    { public declarations }
  End;

Var
  Form1: TForm1;

Implementation

Uses unit2;

{$R *.lfm}

{ TForm1 }

Function Lowerformat(Value: String): String;
Begin
  value := lowercase(value);
  While pos('#13', value) <> 0 Do
    delete(value, pos('#13', value), 1);
  While pos('#10', value) <> 0 Do
    delete(value, pos('#10', value), 1);
  result := trim(value);
End;

Function ToLen(Len: Integer; value: String): String;
Begin
  While UTF8Length(value) < len Do
    value := ' ' + value;
  result := value;
End;

Procedure TForm1.FormCreate(Sender: TObject);
Var
  s: String;
Begin
  // Damit die Form2 auch von form1.create aus erreichbar ist.
  Application.CreateForm(TForm2, Form2);
  OpenDialog1.InitialDir := ExtractFilePath(paramstr(0));
  (* Alle Einstellungen die gemacht werden müssen, geht natürlich auch im OE*)
  (*
   * Die Komponente die die verbindung zum SQL-Server aufbaut
   *)
  SQLite3Connection1.DatabaseName := ''; // Name der Datenbank, case sensitiv
  SQLite3Connection1.Password := ''; // Kein Passwort
  SQLite3Connection1.UserName := ''; // Keine Ahnung für was das ist
  SQLite3Connection1.Transaction := SQLTransaction1;
  (*
   * Transaction Komponente
   *)
  SQLTransaction1.DataBase := SQLite3Connection1;
  (*
   * Die Query Komponente
   *)
  SQLQuery1.DataBase := SQLite3Connection1;
  SQLQuery1.Transaction := SQLTransaction1;
  (*
   *
   *)
  //  SQLite3Connection1.Connected := true; // Befehl zum Verbinden der DB
  (*
   * Eine erste Query, diese zeigt alle Tabellen in der DB an.
   *)
  memo1.clear;
  memo1.lines.add('SELECT name FROM sqlite_master WHERE type = "table";');
  form2.ListBox1.Items.add(memo1.lines.Text);
  memo2.clear;
  s := IncludeTrailingPathDelimiter(ExtractFilePath(paramstr(0))) + 'user.cfg';
  If FileExists(s) Then Begin
    ComboBox1.Items.LoadFromFile(s);
    If ComboBox1.Items.count <> 0 Then
      ComboBox1.ItemIndex := 0
    Else Begin
      showmessage('Error invalid file "' + s + '" please read the readme.txt');
      halt;
    End;
  End
  Else Begin
    showmessage('Error could not find "' + s + '" please read the readme.txt');
    halt;
  End;
  caption := 'Nicht verbunden.';
End;

Procedure TForm1.Memo1KeyDown(Sender: TObject; Var Key: Word; Shift: TShiftState
  );
Begin
  If (ssSHift In Shift) And (key = 13) Then
    Button1.OnClick(Nil);
  form1.BringToFront;
  memo1.SetFocus;
End;

Procedure TForm1.Button1Click(Sender: TObject);

Type
  TCol = Record
    MaxLen: Integer;
    Data: Array Of String;
  End;

  TTableCache = Array Of TCol;

Var
  stt, st: String;
  f: TField;
  s: TStringlist;
  a: TTableCache;
  j, c, i: Integer;
  b: Boolean;
Begin
  If Not SQLite3Connection1.Connected Then Begin
    showmessage('Fehler nicht verbunden.');
    exit;
  End;
  SQLQuery1.Active := false;
  SQLQuery1.SQL.Clear;
  (*
  Die History Geschichte
  *)
  If Not Form2.Visible Then Begin
    Form2.Show;
    form2.left := form1.left - form2.width - 8;
    form2.top := form1.top;
  End;
  form2.BringToFront;
  st := memo1.Text;
  stt := Lowerformat(st);
  b := false;
  For i := 0 To form2.ListBox1.Count - 1 Do Begin
    If stt = Lowerformat(form2.ListBox1.Items[i]) Then Begin
      b := true;
      form2.ListBox1.ItemIndex := i;
      break;
    End;
  End;
  // Einfügen in die History
  If Not b Then Begin
    form2.ListBox1.Items.add(st);
  End;
  If Length(st) <> 0 Then Begin
    SQLQuery1.SQL.Text := st;
  End
  Else Begin
    exit;
  End;
  Try
    SQLQuery1.Open;
  Except
    On e: Exception Do Begin
      ShowMessage('Fehler ungültige Eingabe.'#13'Fehlermeldung:'#13 + e.Message);
      exit;
    End;
  End;
  // Wenn überhaupt etwas ausgelesen werden konnte
  setlength(a, 0);
  If SQLQuery1.Fields.Count <> 0 Then Begin
    setlength(a, SQLQuery1.Fields.Count);
    // Die Labels Setzen
    s := TStringlist.create;
    SQLQuery1.Fields.GetFieldNames(s);
    For i := 0 To s.count - 1 Do Begin
      setlength(a[i].Data, 1);
      a[i].Data[0] := s[i];
      a[i].MaxLen := length(s[i]);
    End;
    // Auslesen aller gesendeter Daten
    While (Not SQLQuery1.EOF) Do Begin
      For i := 0 To s.count - 1 Do Begin
        setlength(a[i].Data, high(a[i].Data) + 2);
        f := SQLQuery1.Fields.FieldByName(s[i]);
        If assigned(f) Then Begin
          //          // Ausgabe nach Typ
          //          Case f.DataType Of
          //            ftInteger: a[i].Data[high(a[i].Data)] := inttostr(f.AsInteger);
          //            ftString: a[i].Data[high(a[i].Data)] := f.AsString;
          //          End;
          // Ausgabe als String, wir wollen ja alles als String haben
          a[i].Data[high(a[i].Data)] := f.AsString;
          // Speichern der Maximalen Breite
          a[i].MaxLen := max(a[i].MaxLen, length(a[i].Data[high(a[i].Data)]));
        End;
      End;
      SQLQuery1.Next;
    End;
    s.free;
  End;
  // Löschen der Alten Ausgabe
  memo2.Clear;
  // Konvertierung der Ausgabe
  If assigned(a) Then Begin
    For j := 0 To high(a[0].Data) Do Begin
      st := '';
      For i := 0 To high(a) Do Begin
        If i <> high(a) Then
          st := st + ToLen(a[i].MaxLen, a[i].Data[j]) + '|'
        Else
          st := st + ToLen(a[i].MaxLen, a[i].Data[j]);
      End;
      memo2.Lines.add(st);
      If j = 0 Then Begin
        c := length(st);
        st := '';
        While length(st) < c Do
          st := st + '-';
        memo2.Lines.add(st);
      End;
    End;
  End;
End;

Procedure TForm1.Button2Click(Sender: TObject);
Var
  s, t: String;
Begin
  If Not SQLite3Connection1.Connected Then Begin
    showmessage('Fehler nicht verbunden.');
    exit;
  End;
  SQLQuery1.Active := false;
  SQLQuery1.SQL.Clear;
  // Unterstützung für "Viele" Befehle hintereinander.
  s := memo1.Text;
  (*
  Bereinigen von s
  *)
  s := trim(s);
  While pos(#10, s) <> 0 Do
    delete(s, pos(#10, s), 1);
  While pos(#13, s) <> 0 Do
    delete(s, pos(#13, s), 1);
  s := trim(s);
  Try
    While pos(';', s) <> 0 Do Begin
      t := copy(s, 1, pos(';', s));
      delete(s, 1, length(t));
      SQLQuery1.SQL.Text := t;
      SQLQuery1.ExecSQL;
      SQLTransaction1.Commit;
    End;
    s := trim(s);
    If length(s) <> 0 Then Begin
      SQLQuery1.SQL.Text := s;
      SQLQuery1.ExecSQL;
      SQLTransaction1.Commit;
    End;
  Except
    On e: Exception Do
      ShowMessage('Fehler ungültige Eingabe.'#13'Fehlermeldung:'#13 + e.Message);
  End;
  memo2.Clear;
End;

Procedure TForm1.Button3Click(Sender: TObject);
Begin
  If SQLite3Connection1.Connected Then
    SQLite3Connection1.Connected := false;
  SQLite3Connection1.DatabaseName := ComboBox1.text;
  Try
    SQLite3Connection1.Connected := true;
  Except
    On e: Exception Do Begin
      ShowMessage('Fehler kann nicht verbinden.'#13'Fehlermeldung:'#13 + e.Message);
      caption := 'Nicht verbunden.';
    End;
  End;
  caption := 'Verbunden mit : ' + ComboBox1.text;
End;

Procedure TForm1.Button4Click(Sender: TObject);
Begin
  close;
End;

Procedure TForm1.Button5Click(Sender: TObject);
Var
  s: String;
Begin
  If SQLite3Connection1.Connected Then Begin
    If OpenDialog1.Execute Then Begin
      s := memo1.Lines.Text;
      memo1.clear;
      memo1.Lines.LoadFromFile(OpenDialog1.FileName);
      Button2.OnClick(Nil);
      memo1.Lines.Text := s;
    End;
  End
  Else Begin
    showmessage('Fehler nicht verbunden.');
  End;
End;

Procedure TForm1.Button6Click(Sender: TObject);
Begin
  If SQLite3Connection1.Connected Then
    SQLite3Connection1.Connected := false;
  SQLite3Connection1.DatabaseName := '';
  caption := 'Nicht Verbunden';
End;

Procedure TForm1.FormChangeBounds(Sender: TObject);
Begin
  If form2.visible Then Begin
    form2.left := form1.left - form2.width - 8;
    form2.top := form1.top;
  End;
End;

Procedure TForm1.FormClose(Sender: TObject; Var CloseAction: TCloseAction);
Begin
End;

Procedure TForm1.FormCloseQuery(Sender: TObject; Var CanClose: boolean);
Begin
  Button6Click(Nil); // Trennen wenn Verbunden
End;

End.

